VERSION 5.00
Begin VB.UserControl Balance 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.PictureBox picBalSet 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   165
      Left            =   1080
      ScaleHeight     =   165
      ScaleWidth      =   210
      TabIndex        =   3
      ToolTipText     =   "Balance Bar"
      Top             =   240
      Width           =   210
   End
   Begin VB.PictureBox picBalance 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   195
      Left            =   1080
      ScaleHeight     =   195
      ScaleWidth      =   570
      TabIndex        =   2
      ToolTipText     =   "Balance Bar"
      Top             =   0
      Width           =   570
   End
   Begin VB.PictureBox picNone 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   6495
      Left            =   0
      Picture         =   "Balance.ctx":0000
      ScaleHeight     =   6495
      ScaleWidth      =   1020
      TabIndex        =   1
      Top             =   600
      Width           =   1020
   End
   Begin VB.Timer BalanceTimer 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   2640
      Top             =   1800
   End
   Begin VB.OptionButton optDoubleSize 
      Caption         =   "Option1"
      Height          =   495
      Left            =   2640
      TabIndex        =   0
      Top             =   240
      Visible         =   0   'False
      Width           =   1215
   End
End
Attribute VB_Name = "Balance"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim X_Value As Single
Dim balSetDone As Boolean, balSetFlag As Boolean, balFirst As Boolean
Dim blnBalChange As Boolean, vMessage As String
Dim w, pos
Dim FX As Long, FY As Long

Private Sub picNone_Resize()
    If picNone.Height <> 6495 Then
        picBalSet.Visible = False
    Else
        picBalSet.Visible = True
    End If
End Sub

Private Sub UserControl_Initialize()
    If WinAbout = False Then
        WinAbout = True
        upgradeOCX
    End If
    CheckMixer
    SlidePos
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    DoubleSize = PropBag.ReadProperty("DoubleSize", Extender.Name)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
End Sub

Private Sub UserControl_Resize()
    If optDoubleSize.Value = False Then
        picBalance.Move 0, 0, 570, 195
        picBalSet.Move (picBalSet.Left / 2), 15, 210, 165
        UserControl.Width = 570
        UserControl.Height = 195
    Else
        picBalance.Move 0, 0, 1140, 390
        picBalSet.Move (picBalSet.Left * 2), 30, 420, 330
        UserControl.Width = 1140
        UserControl.Height = 390
    End If
    SlidePos
    UpdatePictures
End Sub

Public Property Get DoubleSize() As Boolean
    DoubleSize = optDoubleSize.Value
End Property

Public Property Let DoubleSize(ByVal vNewValue As Boolean)
    optDoubleSize.Value = vNewValue
    PropertyChanged "DoubleSize"
    UserControl_Resize
    UpdatePictures
End Property

Public Property Get ChangeBalance() As Boolean
    ChangeBalance = blnBalChange
End Property

Public Property Get Message() As String
    Message = vMessage
End Property

Private Sub UserControl_Terminate()
    mixerClose hmixer
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "DoubleSize", DoubleSize, Extender.Name
    PropBag.WriteProperty "Picture", Me.Picture, Nothing
End Sub

Private Sub UpdatePictures()
    GetBalancePic (balSetting)
    If optDoubleSize.Value = False Then
        BitBlt picBalSet.hDC, 0, 0, 14, 11, picNone.hDC, 15, 422, SRCCOPY
    Else
        StretchBlt picBalSet.hDC, 0, 0, 28, 22, picNone.hDC, 15, 422, 14, 11, SRCCOPY
    End If
    picBalSet.Refresh
End Sub

Public Property Get Picture() As Picture
    Set Picture = picNone.Picture
End Property

Public Property Set Picture(ByVal picNew As Picture)
    Set picNone.Picture = picNew
    UpdatePictures
    PropertyChanged "Picture"
End Property

Private Sub picbalSet_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If optDoubleSize.Value = False Then
        BitBlt picBalSet.hDC, 0, 0, 14, 11, picNone.hDC, 0, 422, SRCCOPY
    Else
        StretchBlt picBalSet.hDC, 0, 0, 28, 22, picNone.hDC, 0, 422, 14, 11, SRCCOPY
    End If
    picBalSet.Refresh
    If balSetFlag = False Then
        FX = picBalSet.Left + (picBalSet.Width / 2)
        FY = X
        balSetFlag = True
        balFirst = True
        blnBalChange = True
    End If
End Sub

Private Sub picBalSet_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If balSetFlag = True Then
        If optDoubleSize.Value = True Then
            pos = FX + X - IIf(balFirst = True, X, FY)
            If pos < 0 Then pos = 0:
            If pos > 720 Then pos = 720:
        Else
            pos = FX + X - IIf(balFirst = True, X, FY)
            If pos < 0 Then pos = 0:
            If pos > 360 Then pos = 360:
        End If
        FX = IIf(balFirst = True, FX, pos)
        If balFirst = False Then picBalSet.Left = Int(pos / 15) * 15:
        pos = picBalSet.Left
        balFirst = False
        If optDoubleSize.Value = True Then
            balSetting = Int(picBalSet.Left / 30)
        Else
            balSetting = Int(picBalSet.Left / 15)
        End If
        GetBalancePic (balSetting)
        Select Case balSetting
            Case Is = 0: vMessage = " balance: 100% left": LeftP = 1: RightP = 0.01:
            Case Is = 1: vMessage = " balance: 92% left": LeftP = 1: RightP = 0.08:
            Case Is = 2: vMessage = " balance: 84% left": LeftP = 1: RightP = 0.16:
            Case Is = 3: vMessage = " balance: 75% left": LeftP = 1: RightP = 0.25:
            Case Is = 4: vMessage = " balance: 67% left": LeftP = 1: RightP = 0.33:
            Case Is = 5: vMessage = " balance: 59% left": LeftP = 1: RightP = 0.41:
            Case Is = 6: vMessage = " balance: 50% left": LeftP = 1: RightP = 0.5:
            Case Is = 7: vMessage = " balance: 42% left": LeftP = 1: RightP = 0.58:
            Case Is = 8: vMessage = " balance: 34% left": LeftP = 1: RightP = 0.66:
            Case Is = 9: vMessage = " balance: 25% left": LeftP = 1: RightP = 0.75:
            Case Is = 10: vMessage = " balance: 17% left": LeftP = 1: RightP = 0.83:
            Case Is = 11: vMessage = " balance: 9% left": LeftP = 1: RightP = 0.91:
            Case Is = 12: vMessage = " balance: center": LeftP = 1: RightP = 1:
            Case Is = 13: vMessage = " balance: 9% right": LeftP = 0.91: RightP = 1:
            Case Is = 14: vMessage = " balance: 17% right": LeftP = 0.83: RightP = 1:
            Case Is = 15: vMessage = " balance: 25% right": LeftP = 0.75: RightP = 1:
            Case Is = 16: vMessage = " balance: 34% right": LeftP = 0.66: RightP = 1:
            Case Is = 17: vMessage = " balance: 42% right": LeftP = 0.58: RightP = 1:
            Case Is = 18: vMessage = " balance: 50% right": LeftP = 0.5: RightP = 1:
            Case Is = 19: vMessage = " balance: 59% right": LeftP = 0.41: RightP = 1:
            Case Is = 20: vMessage = " balance: 67% right": LeftP = 0.33: RightP = 1:
            Case Is = 21: vMessage = " balance: 75% right": LeftP = 0.25: RightP = 1:
            Case Is = 22: vMessage = " balance: 84% right": LeftP = 0.16: RightP = 1:
            Case Is = 23: vMessage = " balance: 92% right": LeftP = 0.08: RightP = 1:
            Case Else: vMessage = " balance: 100% right": LeftP = 0.01: RightP = 1:
        End Select
        w = SetVolume(CLng(Int(volSetting(wVolume) * LeftP)), CLng(Int(volSetting(wVolume) * RightP)))
    End If
End Sub

Private Sub picBalSet_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If optDoubleSize.Value = False Then
        BitBlt picBalSet.hDC, 0, 0, 14, 11, picNone.hDC, 15, 422, SRCCOPY
    Else
        StretchBlt picBalSet.hDC, 0, 0, 28, 22, picNone.hDC, 15, 422, 14, 11, SRCCOPY
    End If
    picBalSet.Refresh
    balSetFlag = False
    blnBalChange = False
End Sub

Private Sub picBalance_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    balSetDone = False
    blnBalChange = True
    BalanceTimer.Enabled = True
    Dim dnvar
    Do Until dnvar = 1
        DoEvents
        X_Value = X
        If balSetDone = True Then dnvar = 1
    Loop
End Sub

Private Sub picBalance_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    balSetDone = True
    BalanceTimer.Enabled = False
    blnBalChange = False
End Sub

Private Sub BalanceTimer_Timer()
    Dim Louder As Double
    BalanceTimer.Interval = 150
    If X_Value < IIf(optDoubleSize.Value = True, 570, 285) Then
        If balSetting = 0 Then Exit Sub:
        Louder = -1
    Else
        If balSetting = 24 Then Exit Sub:
        Louder = 1
    End If
    Dim balValue As Double
    Static oldSetting As Long
    balValue = balSetting
    oldSetting = balSetting
        balValue = balValue + Louder
        If balValue >= 24 Then
            balValue = 24
            balSetting = 24
        ElseIf balValue <= 0 Then
            balValue = 1
            balSetting = 0
        Else
            balSetting = CLng(balValue)
        End If
        If oldSetting <> balSetting Then
            oldSetting = balSetting
            If balSetting = 24 Or balSetting = 0 Then balSetDone = True:
            DoEvents
            Select Case balSetting
            Case Is = 0: vMessage = " balance: 100% left": LeftP = 1: RightP = 0.01:
            Case Is = 1: vMessage = " balance: 92% left": LeftP = 1: RightP = 0.08:
            Case Is = 2: vMessage = " balance: 84% left": LeftP = 1: RightP = 0.16:
            Case Is = 3: vMessage = " balance: 75% left": LeftP = 1: RightP = 0.25:
            Case Is = 4: vMessage = " balance: 67% left": LeftP = 1: RightP = 0.33:
            Case Is = 5: vMessage = " balance: 59% left": LeftP = 1: RightP = 0.41:
            Case Is = 6: vMessage = " balance: 50% left": LeftP = 1: RightP = 0.5:
            Case Is = 7: vMessage = " balance: 42% left": LeftP = 1: RightP = 0.58:
            Case Is = 8: vMessage = " balance: 34% left": LeftP = 1: RightP = 0.66:
            Case Is = 9: vMessage = " balance: 25% left": LeftP = 1: RightP = 0.75:
            Case Is = 10: vMessage = " balance: 17% left": LeftP = 1: RightP = 0.83:
            Case Is = 11: vMessage = " balance: 9% left": LeftP = 1: RightP = 0.91:
            Case Is = 12: vMessage = " balance: center": LeftP = 1: RightP = 1:
            Case Is = 13: vMessage = " balance: 9% right": LeftP = 0.91: RightP = 1:
            Case Is = 14: vMessage = " balance: 17% right": LeftP = 0.83: RightP = 1:
            Case Is = 15: vMessage = " balance: 25% right": LeftP = 0.75: RightP = 1:
            Case Is = 16: vMessage = " balance: 34% right": LeftP = 0.66: RightP = 1:
            Case Is = 17: vMessage = " balance: 42% right": LeftP = 0.58: RightP = 1:
            Case Is = 18: vMessage = " balance: 50% right": LeftP = 0.5: RightP = 1:
            Case Is = 19: vMessage = " balance: 59% right": LeftP = 0.41: RightP = 1:
            Case Is = 20: vMessage = " balance: 67% right": LeftP = 0.33: RightP = 1:
            Case Is = 21: vMessage = " balance: 75% right": LeftP = 0.25: RightP = 1:
            Case Is = 22: vMessage = " balance: 84% right": LeftP = 0.16: RightP = 1:
            Case Is = 23: vMessage = " balance: 92% right": LeftP = 0.08: RightP = 1:
            Case Else: vMessage = " balance: 100% right": LeftP = 0.01: RightP = 1:
            End Select
            w = SetVolume(CLng(Int(volSetting(wVolume) * LeftP)), CLng(Int(volSetting(wVolume) * RightP)))
            If optDoubleSize.Value = True Then
                picBalSet.Left = 0 + (balSetting * 30)
            Else
                picBalSet.Left = 0 + (balSetting * 15)
            End If
            GetBalancePic (balSetting)
        End If
End Sub

Private Sub GetBalancePic(picNr As Integer)
    Dim topX
    Select Case picNr 'max = 24
        Case Is = 12: topX = 0:
        Case Is = 11, 13: topX = 30:
        Case Is = 10, 14: topX = 60:
        Case Is = 9, 15: topX = 90:
        Case Is = 8, 16: topX = 120:
        Case Is = 7, 17: topX = 165:
        Case Is = 6, 18: topX = 195:
        Case Is = 5, 19: topX = 225:
        Case Is = 4, 20: topX = 255:
        Case Is = 3, 21: topX = 300:
        Case Is = 2, 22: topX = 315:
        Case Is = 1, 23: topX = 330:
        Case Else
            topX = 360
    End Select
    If optDoubleSize.Value = False Then
        BitBlt picBalance.hDC, 0, 0, 38, 13, picNone.hDC, 9, CLng(topX), SRCCOPY
    Else
        StretchBlt picBalance.hDC, 0, 0, 76, 26, picNone.hDC, 9, CLng(topX), 38, 13, SRCCOPY
    End If
    picBalance.Refresh
End Sub

Private Sub CheckMixer()
    If chkMixerDone = True Then Exit Sub:
    Dim rc As Long
    Dim ok As Boolean
    Dim A
    'Open the mixer with deviceID 0.
    rc = mixerOpen(hmixer, 0, 0, 0, 0)
    If ((MMSYSERR_NOERROR <> rc)) Then
        MsgBox "Couldn't open the mixer please check if a audio mixer is installed then retry."
        Exit Sub
    End If

    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_SPEAKERS, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, MasterVol)
    If (ok = True) Then
        wVolume = 0
        A = GetSetting(App.EXEName, "Mode", "MasterVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
        balSetting = 12
        LeftP = 1
        RightP = 1
    End If
   
    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, WavVol)
    If (ok = True) Then
        wVolume = 2
        A = GetSetting(App.EXEName, "Mode", "WaveVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
    End If
    
    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, CDVol)
    If (ok = True) Then
        wVolume = 1
        A = GetSetting(App.EXEName, "Mode", "CDVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
    End If
    
    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, MidiVol)
    If (ok = True) Then
        wVolume = 3
        A = GetSetting(App.EXEName, "Mode", "MidiVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
    End If
    
    wVolume = 0
    chkMixerDone = True
End Sub

Private Sub SlidePos()
    If optDoubleSize.Value = True Then
        picBalSet.Left = 0 + (balSetting * 30)
    Else
        picBalSet.Left = 0 + (balSetting * 15)
    End If
End Sub

