VERSION 5.00
Begin VB.UserControl Volume 
   ClientHeight    =   2445
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   2445
   ScaleWidth      =   4800
   Begin VB.PictureBox picVolSet 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   165
      Left            =   1080
      ScaleHeight     =   165
      ScaleWidth      =   210
      TabIndex        =   3
      ToolTipText     =   "Volume Bar"
      Top             =   240
      Width           =   210
   End
   Begin VB.OptionButton optDoubleSize 
      Caption         =   "Option1"
      Height          =   495
      Left            =   2640
      TabIndex        =   2
      Top             =   240
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Timer VolumeTimer 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   2640
      Top             =   1800
   End
   Begin VB.PictureBox picNone 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   6495
      Left            =   0
      Picture         =   "Volume.ctx":0000
      ScaleHeight     =   6495
      ScaleWidth      =   1020
      TabIndex        =   1
      Top             =   600
      Width           =   1020
   End
   Begin VB.PictureBox picVolume 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   195
      Left            =   1080
      ScaleHeight     =   195
      ScaleWidth      =   1020
      TabIndex        =   0
      ToolTipText     =   "Volume Bar"
      Top             =   0
      Width           =   1020
   End
End
Attribute VB_Name = "Volume"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim X_Value As Single
Dim volSetDone As Boolean, volSetFlag As Boolean, volFirst As Boolean
Dim blnVolChange As Boolean, vMessage As String
Dim w, pos
Dim FX As Long, FY As Long

Enum dvcVolume
    dvcMaster = 0
    dvcCD = 1
    dvcWav = 2
    dvcMidi = 3
End Enum

Private Sub picNone_Resize()
    If picNone.Height <> 6495 Then
        picVolSet.Visible = False
    Else
        picVolSet.Visible = True
    End If
End Sub

Private Sub UserControl_Initialize()
    If WinAbout = False Then
        WinAbout = True
        upgradeOCX
    End If
    CheckMixer
    picVolume.Left = 0
    SlidePos
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    DoubleSize = PropBag.ReadProperty("DoubleSize", Extender.Name)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    VolumeDevice = PropBag.ReadProperty("VolumeDevice", Extender.Name)
End Sub

Private Sub UserControl_Resize()
    If optDoubleSize.Value = False Then
        picVolume.Move 0, 0, 1020, 195
        UserControl.Width = 1020
        UserControl.Height = 195
        picVolSet.Move (picVolSet.Left / 2), 15, 210, 165
    Else
        picVolume.Move 0, 0, 2040, 390
        UserControl.Width = 2040
        UserControl.Height = 390
        picVolSet.Move (picVolSet.Left * 2), 30, 420, 330
    End If
    SlidePos
    UpdatePictures
End Sub

Public Property Get DoubleSize() As Boolean
    DoubleSize = optDoubleSize.Value
End Property

Public Property Let DoubleSize(ByVal vNewValue As Boolean)
    optDoubleSize.Value = vNewValue
    PropertyChanged "DoubleSize"
    UserControl_Resize
    UpdatePictures
End Property

Public Function ChangeVolume() As Boolean
    ChangeVolume = blnVolChange
End Function

Public Function Message() As String
    Message = vMessage
End Function

Private Sub UserControl_Terminate()
    SaveVolSettings
    mixerClose hmixer
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "DoubleSize", DoubleSize, Extender.Name
    PropBag.WriteProperty "Picture", Me.Picture, Nothing
    PropBag.WriteProperty "VolumeDevice", VolumeDevice, Extender.Name
End Sub

Private Sub UpdatePictures()
    GetVolumePic Int((volSetting(wVolume)) / 2)
    If optDoubleSize.Value = False Then
        BitBlt picVolSet.hDC, 0, 0, 14, 11, picNone.hDC, 15, 422, SRCCOPY
    Else
        StretchBlt picVolSet.hDC, 0, 0, 28, 22, picNone.hDC, 15, 422, 14, 11, SRCCOPY
    End If
    picVolSet.Refresh
End Sub

Public Property Get Picture() As Picture
    Set Picture = picNone.Picture
End Property

Public Property Set Picture(ByVal picNew As Picture)
    Set picNone.Picture = picNew
    UpdatePictures
    PropertyChanged "Picture"
End Property

Private Sub PicVolSet_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If optDoubleSize.Value = False Then
        BitBlt picVolSet.hDC, 0, 0, 14, 11, picNone.hDC, 0, 422, SRCCOPY
    Else
        StretchBlt picVolSet.hDC, 0, 0, 28, 22, picNone.hDC, 0, 422, 14, 11, SRCCOPY
    End If
    picVolSet.Refresh
    If volSetFlag = False Then
        FX = picVolSet.Left + (picVolSet.Width / 2)
        FY = X
        volSetFlag = True
        volFirst = True
        blnVolChange = True
    End If
End Sub

Private Sub PicVolSet_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If volSetFlag = True Then
        If optDoubleSize.Value = True Then
            pos = FX + X - IIf(volFirst = True, X, FY)
            If pos < 0 Then pos = 0:
            If pos > 1620 Then pos = 1620:
        Else
            pos = FX + X - IIf(volFirst = True, X, FY)
            If pos < 0 Then pos = 0:
            If pos > 810 Then pos = 810:
        End If
        FX = IIf(volFirst = True, FX, pos)
        If volFirst = False Then picVolSet.Left = Int(pos / 15) * 15:
        pos = picVolSet.Left
        volFirst = False
        vMessage = " volume: " & IIf(optDoubleSize.Value = True, Trim(Int((pos / (picVolume.Width - picVolSet.Width)) * 100)), Trim(Int((pos / (picVolume.Width - picVolSet.Width)) * 100))) & "%"
        If optDoubleSize.Value = True Then
            volSetting(wVolume) = Int(picVolSet.Left / 30)
        Else
            volSetting(wVolume) = Int(picVolSet.Left / 15)
        End If
        GetVolumePic Int((volSetting(wVolume)) / 2)
        w = SetVolume(CLng(Int(volSetting(wVolume) * LeftP)), CLng(Int(volSetting(wVolume) * RightP)))
    End If
End Sub

Private Sub PicVolSet_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If optDoubleSize.Value = False Then
        BitBlt picVolSet.hDC, 0, 0, 14, 11, picNone.hDC, 15, 422, SRCCOPY
    Else
        StretchBlt picVolSet.hDC, 0, 0, 28, 22, picNone.hDC, 15, 422, 14, 11, SRCCOPY
    End If
    picVolSet.Refresh
    volSetFlag = False
    blnVolChange = False
    SaveVolSettings
End Sub

Private Sub PicVolume_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    volSetDone = False
    blnVolChange = True
    VolumeTimer.Enabled = True
    Dim dnvar
    Do Until dnvar = 1
        DoEvents
        X_Value = X
        If volSetDone = True Then dnvar = 1
    Loop
End Sub

Private Sub PicVolume_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    volSetDone = True
    VolumeTimer.Enabled = False
    blnVolChange = False
    SaveVolSettings
End Sub

Private Sub VolumeTimer_Timer()
    Dim Louder As Double
    If X_Value < IIf(optDoubleSize.Value = True, 340, 170) Then
        If volSetting(wVolume) = 0 Then Exit Sub:
        Louder = -500  '0.05
        VolumeTimer.Interval = 150
    ElseIf X_Value < IIf(optDoubleSize.Value = True, 1020, 510) Then
        If volSetting(wVolume) = 0 Then Exit Sub:
        Louder = -500  '0.5
        VolumeTimer.Interval = 50
    ElseIf X_Value < IIf(optDoubleSize.Value = True, 1700, 850) Then
        If volSetting(wVolume) = 54 Then Exit Sub:
        Louder = 500 '0.5
        VolumeTimer.Interval = 50
    Else
        If volSetting(wVolume) = 54 Then Exit Sub:
        Louder = 500 '0.05
        VolumeTimer.Interval = 150
    End If
    Dim volValue As Double
    Static oldSetting As Long
    volValue = volSetting(wVolume) * 500
    oldSetting = volSetting(wVolume)
        volValue = volValue + Louder
        If volValue >= 27000 Then
            volValue = 27000
            volSetting(wVolume) = 54
        ElseIf volValue <= 0 Then
            volValue = 1
            volSetting(wVolume) = 0
        Else
            volSetting(wVolume) = CLng(Int(volValue / 500))
        End If
        If oldSetting <> volSetting(wVolume) Then
            oldSetting = volSetting(wVolume)
            If volSetting(wVolume) = 54 Or volSetting(wVolume) = 0 Then volSetDone = True:
            DoEvents
            w = SetVolume(CLng(Int(volSetting(wVolume) * LeftP)), CLng(Int(volSetting(wVolume) * RightP)))
            If optDoubleSize.Value = True Then
                picVolSet.Left = 0 + ((volSetting(wVolume)) * 30)
            Else
                picVolSet.Left = 0 + ((volSetting(wVolume)) * 15)
            End If
            GetVolumePic (Int((volSetting(wVolume)) / 2))
            vMessage = " volume: " & IIf(optDoubleSize.Value = True, Trim(Int((picVolSet.Left / (picVolume.Width - picVolSet.Width)) * 100)), Trim(Int((picVolSet.Left / (picVolume.Width - picVolSet.Width)) * 100))) & "%"
        End If
End Sub

Private Sub GetVolumePic(picNr As Integer)
    Dim topX, i
    For i = 0 To picNr 'max = 27
        If i = 0 Then
            topX = 0
        Else
            topX = topX + 15
        End If
    Next
    If optDoubleSize.Value = False Then
        BitBlt picVolume.hDC, 0, 0, 68, 13, picNone.hDC, 0, CLng(topX), SRCCOPY
    Else
        StretchBlt picVolume.hDC, 0, 0, 136, 26, picNone.hDC, 0, CLng(topX), 68, 13, SRCCOPY
    End If
    picVolume.Refresh
End Sub

Private Sub CheckMixer()
    If chkMixerDone = True Then Exit Sub:
    Dim rc As Long
    Dim ok As Boolean
    Dim A
    'Open the mixer with deviceID 0.
    rc = mixerOpen(hmixer, 0, 0, 0, 0)
    If ((MMSYSERR_NOERROR <> rc)) Then
        MsgBox "Couldn't open the mixer please check if a audio mixer is installed then retry."
        Exit Sub
    End If

    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_DST_SPEAKERS, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, MasterVol)
    If (ok = True) Then
        wVolume = 0
        A = GetSetting(App.EXEName, "Mode", "MasterVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
        balSetting = 12
        LeftP = 1
        RightP = 1
    End If
   
    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, CDVol)
    If (ok = True) Then
        wVolume = 1
        A = GetSetting(App.EXEName, "Mode", "CDVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
    End If
    
    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, WavVol)
    
    If (ok = True) Then
        wVolume = 2
        A = GetSetting(App.EXEName, "Mode", "WaveVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
    End If
    
    ok = GetMixerControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER, _
                                  MIXERCONTROL_CONTROLTYPE_VOLUME, MidiVol)
    If (ok = True) Then
        wVolume = 3
        A = GetSetting(App.EXEName, "Mode", "MidiVol", 27)
        volSetting(wVolume) = IIf(IsNumeric(A) = True And IsEmpty(A) = False, A, 27)
        If volSetting(wVolume) < 0 And volSetting(wVolume) > 54 Then volSetting(wVolume) = 27:
        w = SetVolume(volSetting(wVolume), volSetting(wVolume))
    End If
    
    wVolume = 0
    chkMixerDone = True
End Sub

Public Property Let VolumeDevice(vDevice As dvcVolume)
    wVolume = vDevice
    SlidePos
    PropertyChanged "VolumeDevice"
End Property

Public Property Get VolumeDevice() As dvcVolume
    VolumeDevice = wVolume
End Property

Private Sub SaveVolSettings()
    SaveSetting App.EXEName, "Mode", "MasterVol", volSetting(0)
    SaveSetting App.EXEName, "Mode", "CDVol", volSetting(1)
    SaveSetting App.EXEName, "Mode", "WaveVol", volSetting(2)
    SaveSetting App.EXEName, "Mode", "MidiVol", volSetting(3)
End Sub

Private Sub SlidePos()
    GetVolumePic Int((volSetting(wVolume)) / 2)
    If optDoubleSize.Value = True Then
        picVolSet.Left = 0 + ((volSetting(wVolume)) * 30)
    Else
        picVolSet.Left = 0 + ((volSetting(wVolume)) * 15)
    End If
End Sub

